/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Fabian Reister ( fabian dot reister at kit dot edu )
 * @date       2021
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <mutex>
#include <optional>

#include <RobotAPI/libraries/armem/client/util/SimpleWriterBase.h>
#include <RobotAPI/libraries/armem_objects/aron_conversions.h>
#include <RobotAPI/libraries/armem_objects/types.h>

namespace armarx::armem::obj::clazz
{
    class ClassWriter : public armem::client::util::SimpleWriterBase
    {
    public:
        ClassWriter() = default;
        ClassWriter(const std::string& p);

        void setProviderName(const std::string& pName);

        bool commitObjectClass(const armarx::armem::clazz::ObjectClass& c,
                               const armarx::core::time::DateTime& referenceTime);

    protected:
        std::string propertyPrefix() const final;
        Properties defaultProperties() const final;

    private:
        std::string providerName;
    };


} // namespace armarx::armem::obj::clazz
