#include "aron_conversions.h"

#include <algorithm>
#include <cstdint>
#include <iterator>

#include <RobotAPI/libraries/armem/core/aron_conversions.h>
#include <RobotAPI/libraries/aron/common/aron_conversions.h>
#include <RobotAPI/libraries/aron/core/data/variant/complex/NDArray.h>

#include "types.h"

namespace armarx::armem::vision
{


    /************ toAron ************/

    void
    toAron(arondto::OccupancyGrid& dto, const OccupancyGrid& bo)
    {
        aron::toAron(dto.frame, bo.frame);
        aron::toAron(dto.pose, bo.pose);
        aron::toAron(dto.resolution, bo.resolution);
        // bo.grid is NdArray -> need special handling.
    }

    void
    fromAron(const arondto::OccupancyGrid& dto, OccupancyGrid& bo)
    {
        aron::fromAron(dto.frame, bo.frame);
        aron::fromAron(dto.pose, bo.pose);
        aron::fromAron(dto.resolution, bo.resolution);
        // bo.grid is NdArray -> need special handling.
    }

} // namespace armarx::armem::vision
