#include "simox.h"

#include <RobotAPI/libraries/aron/common/aron/AxisAlignedBoundingBox.aron.generated.h>
#include <RobotAPI/libraries/aron/common/aron/Color.aron.generated.h>
#include <RobotAPI/libraries/aron/common/aron/OrientedBox.aron.generated.h>

void
armarx::aron::simox::fromAron(const arondto::AxisAlignedBoundingBox& dto,
                              ::simox::AxisAlignedBoundingBox& bo)
{
    bo.center() = dto.center;
    bo.extents() = dto.extents;
}

void
armarx::aron::simox::toAron(arondto::AxisAlignedBoundingBox& dto,
                            const ::simox::AxisAlignedBoundingBox& bo)
{
    dto.center = bo.center();
    dto.extents = bo.extents();
}

void
armarx::aron::simox::fromAron(const arondto::OrientedBox& dto, ::simox::OrientedBoxf& bo)
{
    bo = ::simox::OrientedBoxf(dto.center, dto.orientation, dto.extents);
}

void
armarx::aron::simox::toAron(arondto::OrientedBox& dto, const ::simox::OrientedBoxf& bo)
{
    dto.center = bo.center();
    dto.orientation = bo.rotation();
    dto.extents = bo.dimensions();
}

void
armarx::aron::simox::fromAron(const arondto::Color& dto, ::simox::Color& bo)
{
    bo.r = dto.r;
    bo.g = dto.g;
    bo.b = dto.b;
    bo.a = dto.a;
}

void
armarx::aron::simox::toAron(arondto::Color& dto, const ::simox::Color& bo)
{
    dto.r = bo.r;
    dto.g = bo.g;
    dto.b = bo.b;
    dto.a = bo.a;
}
