/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    robdekon
 * @author     Christoph Pohl ( christoph dot pohl at kit dot edu )
 * @date       07.09.22
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <ArmarXGui/libraries/RemoteGui/RemoteGui.h>

#include <RobotAPI/libraries/aron/core/codegeneration/cpp/AronGeneratedClass.h>
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>
#include <RobotAPI/libraries/aron/core/data/variant/forward_declarations.h>

#include "RemoteGuiVisitors.h"

namespace armarx::RemoteGui
{
    template <typename T>
    concept isAronGenerated = std::is_base_of<armarx::aron::cpp::AronGeneratedClass, T>::value;

    template <typename AronStructT>
        requires isAronGenerated<AronStructT>
    detail::GroupBoxBuilder
    makeConfigGui(const std::string& name, const AronStructT& val)
    {
        aron::component_config::MakeConfigGuiVisitor vis(name);
        armarx::aron::data::visitRecursive(vis, val.toAron(), val.ToAronType());
        return vis.getGroupBoxBuilder();
    }

    //    template <typename AronStructT>
    //    requires isAronGenerated<AronStructT>
    //    void getValueFromMap(AronStructT& cfg,
    //                         RemoteGui::ValueMap const& values, std::string const& name)
    //    {
    //        armarx::aron::component_config::GetValueFromMapVisitor vis(&values);
    //        auto data = std::static_pointer_cast<armarx::aron::data::Variant>(cfg.toAron());
    //        auto type = cfg.ToAronType();
    //        armarx::aron::data::visitRecursive(vis, data, type);
    //        cfg.fromAron(std::static_pointer_cast<armarx::aron::data::Dict>(data));
    //    }

} // namespace armarx::RemoteGui